extends Node2D

var BULLET = preload("res://bullet/bullet.tscn");
var drone = preload('res://unit/unit.tscn');
@onready var MAIN_TARGET = get_tree().current_scene.find_child("main_target");

var MAX_BULLETS = 5000;
var AVAILABLE_BULLETS = [];
var USED_BULLETS = {};
var enemies = {};
var drones = {};
var droneCounter = 1;

# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	pass # Replace with function body.

func _init_bullets():
	for i in range(MAX_BULLETS):
		var bullet = create_bullet(i);
		add_child(bullet);
		AVAILABLE_BULLETS.push_back(bullet);
func create_bullet(id):
	var bullet = BULLET.instantiate();
	bullet.DAMAGE = 1;
	bullet.ID = id;
	bullet.visible = false;
	bullet.process_mode = Node.PROCESS_MODE_DISABLED;
	bullet.SOURCE = self;
	return bullet;
func _spawn_bullet(spawner, dmg):
	if(AVAILABLE_BULLETS.size() < 1):
		var new_bullet = create_bullet(AVAILABLE_BULLETS.size() + USED_BULLETS.size());
		add_child(new_bullet);
		AVAILABLE_BULLETS.push_back(new_bullet);
	var bul = AVAILABLE_BULLETS.pop_back();
	USED_BULLETS[bul.ID] = bul;
	bul._new_setup(dmg, spawner)
func _return_bullet(bullet):
	AVAILABLE_BULLETS.push_back(bullet);
	USED_BULLETS.erase(bullet.ID);
	bullet.visible = false;
	bullet.process_mode = Node.PROCESS_MODE_DISABLED;

func _spawn_drone(params, updateCounter = true):
	randomize()
	var temp_enemy = drone.instantiate();
	temp_enemy.position = Vector2(
	randf_range(MAIN_TARGET.global_position.x - 750, MAIN_TARGET.global_position.x + 750),
	randf_range(MAIN_TARGET.global_position.y - 750, MAIN_TARGET.global_position.y + 750)
	);

	enemies[droneCounter] = temp_enemy
	drones[droneCounter] = temp_enemy;

	droneCounter += 1;

	add_child(temp_enemy)


func _physics_process(delta: float) -> void:
	for key in USED_BULLETS:
		USED_BULLETS[key].global_position += USED_BULLETS[key].vel * delta;
		USED_BULLETS[key].elapsed += delta
		if(USED_BULLETS[key].elapsed >= USED_BULLETS[key].time_to_live):
			USED_BULLETS[key].call_deferred("_disable_bullet");
	for key in drones:
		drones[key]._core_logic_tick(delta);
	if (drones.size() < (75) and true):
		_spawn_drone({});
