extends RigidBody2D

@onready var MAIN_TARGET = get_tree().current_scene.find_child("main_target");
@onready var MANAGER = get_tree().current_scene;

var DEFAULT_STATS = {
	'speed': 150.0,
	'rotationSpeed': 4.0,
	'damage': 10.0
}

var angleTo = 0.0;
var absAngle = 0.0;
var angleSign = -1.0;
var elapsed = 0.0;
var operation_mode = 4;
var default_shoot_angle = 0.2;
var shoot_angle = default_shoot_angle;
var burst_CD = 0.01;
var current_shot = 0;
var num_burst = 3;
var shoot_CD = 1;

# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	pass # Replace with function body.


func _core_logic_tick(delta):
	apply_central_impulse(transform.x * DEFAULT_STATS['speed'] * delta);
	angleTo = transform.x.angle_to(MAIN_TARGET.global_position - global_position);
	absAngle = abs(angleTo);
	angleSign = sign(angleTo)
	if(absAngle > 0.01):
		rotate(angleSign * min(delta * DEFAULT_STATS['rotationSpeed'], absAngle))

	match operation_mode:
		4:
			#Need to shoot
			if(absAngle <= shoot_angle):
				if(elapsed <= 0):#Time to shoot another burst
					operation_mode = 2
				else:#Need to wait CD from previous burst
					elapsed -= delta
		3:#waiting for burst cooldown
			if(elapsed <= 0):
				operation_mode = 4
			else:
				elapsed -= delta
		2:#bursting
			# enough time passed to shoot again
			if(elapsed <= 0):
				#need code to spawn bullet
				elapsed = burst_CD
				current_shot += 1
				MANAGER.call_deferred("_spawn_bullet", self, DEFAULT_STATS.damage);

				if(current_shot >= num_burst):
					operation_mode = 3
					elapsed = shoot_CD
					current_shot = 0
			else:
				elapsed -= delta
